#! /usr/bin/env python3 -B

from testlib import check, runtests, check_text_file, check_img_file, check_json_file
import isrecursive
import copy, albero, re

import program

###############################################################################
def test_nome_cognome_matricola():
    assert program.nome        != 'NOME',      "ATTENZIONE, NON HAI INSERITO IL TUO NOME NEL FILE program.py !!!"
    assert program.cognome     != 'COGNOME',   "ATTENZIONE, NON HAI INSERITO IL TUO COGNOME NEL FILE program.py !!!"
    assert program.matricola   != 'MATRICOLA', "ATTENZIONE, NON HAI INSERITO LA TUA MATRICOLA NEL FILE program.py !!!"
    return 0

###############################################################################

def test_es2a(lista, expected):
    tree   = albero.AlberoBinario.fromList(lista)
    treeBis = copy.deepcopy(tree)
    try:
        isrecursive.decorate_module(program)
        program.es2(treeBis)
    except isrecursive.RecursionDetectedError:
        pass
    else:
        raise Exception("Recursion not present")
    finally:
        isrecursive.undecorate_module(program)

    ris= program.es2(tree)
    check(ris,expected,None,"il valore restituito non e' corretto")
    return 2

def test_es2a_1():
    '''\nProva con in input l'albero:
        
             7       
            /\       
           1  3      
          / \        
        4    6       
       /    /        
      5    2         
     /     \         
    9       8        
    '''
    lista  = [7, [1, [4, [5, [9, None, None], None], None], [6, [2, None, [8, None, None]], None]], [3, None, None]]
    return test_es2a(lista, 2)

def test_es2a_2():
    '''\nProva con in input l'albero:
        
                9               
               /  \             
              /    \            
             /      \           
            /        \          
           /          \         
          2            4        
        /   \        /   \      
       6     6      6     6     
      / \   / \    / \   / \    
     5  5  5   5  5   5 5   5    
    '''
    lista = [9,[2,[6,[5, None, None],[5, None, None]],[6,[5, None, None],[5, None, None]]],
        [4,[6,[5, None, None],[5, None, None]],[6,[5, None, None],[5, None, None]]]]
    return test_es2a(lista, 7)

def test_es2a_3():
    '''\nProva con in input l'albero:
        
         5        
          \       
           1      
          /       
        5         
         \        
          1       
          /       
         5        
    '''
    lista = [5,None,[1,[5,None,[1,[5,None,None],None]],None]]
    return test_es2a(lista, 0)

###############################################################################

def test_es3a_1():
    '''\nPrimo test della funzione es3 con le immagini foto1.png e foto2.png e test1.png.
L'immagine salvata  in test1.png  deve corrispondere a quella in RisTest1.png 
    '''
    returned = program.es3('foto1.png','foto2.png','test1.png')
    check(returned, 30003, None, "il valore restituito non e' corretto")
    check_img_file('test1.png', 'RisTest1.png')

    return 2
    
def test_es3a_2():
    '''\nSecondo test della funzione es3 con le immagini foto1.png e foto3.png e test2.png.
L'immagine salvata  in test2.png  deve corrispondere a quella in RisTest2.png 
    '''
    returned = program.es3('foto1.png','foto3.png','test2.png')
    check(returned, 2573, None, "il valore restituito non e' corretto")
    check_img_file('test2.png', 'RisTest2.png')
    return 2
    
def test_es3a_3():
    '''\nTerzo test della funzione es3 con le immagini foto3.png e foto1.png e test3.png.
L'immagine salvata  in test3.png  deve corrispondere a quella in RisTest3.png 
    '''
    returned = program.es3('foto3.png','foto1.png','test3.png')
    check(returned, 2630, None, "il valore restituito non e' corretto")
    check_img_file('test3.png', 'RisTest3.png')
    return 2

###############################################################################

def test_es5a_1():
    ''' \nPrimo  test della funzione es5 con s='9135918246556' e  k=3 '''
    ris = program.es5('9135918246556',3)
    check(ris, ['359', '246', '135'], None, " la risposta non e' corretta")
    return 1
    
def test_es5a_2():
    ''' \nSecondo test della funzione es5 con s='1234123412341234' e  k=3 '''
    ris = program.es5('1234123412341234',3)
    check(ris, ['234', '123'], None, " la risposta non e' corretta")
    return 1
    
def test_es5a_3():
    ''' \nTerzo test della funzione es5 con s='987654321' e  k=3 '''
    ris = program.es5('987654321',3)
    check(ris, [], None, " la risposta non e' corretta")
    return 1

################################################################################

def test_es7a_1():
    ''' \nPrimo  test della funzione es7 dove  viene passata la lista contenente 
    [ 'Angelo', 'Andrea', 'Fabio', 'Francesco', 'Lucio','Luca', 'Ugo'] e c='a' '''
    lista7_1= [ 'Angelo', 'Andrea', 'Fabio', 'Francesco', 'Lucio','Luca', 'Ugo']
    ris = program.es7(lista7_1,'a')
    check(ris, 5, None, " il numero restituito non e' corretto")
    check(lista7_1, ['Lucio', 'Ugo'], None, " la lista non risulta modificata correttamente")
    return 1
    
def test_es7a_2():
    ''' \nSecondo test della funzione es7 dove viene passata la lista contenente 
    [ 'Angelo', 'Andrea', 'Fabio', 'Francesco', 'Lucio','Luca', 'Ugo'] e c='G' '''
    lista7_2= [ 'Angelo', 'Andrea', 'Fabio', 'Francesco', 'Lucio','Luca', 'Ugo']
    ris = program.es7(lista7_2,'G' )
    check(ris, 2, None, " il numero restituito non e' corretto")
    check(lista7_2, ['Andrea', 'Fabio', 'Francesco', 'Lucio', 'Luca'], None, " la lista non risulta modificata correttamente")
    return 1
    
def test_es7a_3():
    ''' \nTerzo test della funzione es7 dove viene passata la lista contenente 
    [ 'Angelo', 'Andrea', 'Fabio', 'Francesco', 'Lucio','Luca', 'Ugo'] e c='f' '''
    lista7_3= [ 'Angelo', 'Andrea', 'Fabio', 'Francesco', 'Lucio','Luca', 'Ugo']
    ris = program.es7(lista7_3,'f' )
    check(ris, 2, None, " il numero restituito non e' corretto")
    check(lista7_3, ['Angelo', 'Andrea', 'Lucio', 'Luca', 'Ugo'], None, " la lista non risulta modificata correttamente")
    return 1

################################################################################

def test_es9a_1():
    ''' \nPrimo  test della funzione es9 dove vengono passati i due dizionari:
    d1={(0,2): 4,(1,0): 1, (1,1): 2, (2,1):8 }
    d2={(0,0): 5,(1,1): 2, (2,2): 5, (1,0):2 }'''
    da={(0,2): 4,(1,0): 1, (1,1): 2, (2,1):8 }
    db={(0,0): 5,(1,1): 2, (2,2): 5, (1,0):2 }
    returned = program.es9(da,db)
    check(da, {(0,2): 4,(1,0): 1, (1,1): 2, (2,1):8 }, None, "I dizionari in input non vanno modificati")
    check(db, {(0,0): 5,(1,1): 2, (2,2): 5, (1,0):2 }, None, "I dizionari in input non vanno modificati")
    check(returned, {(0,2): 4,(1,0): 3, (1,1): 4, (2,1):8, (0,0):5, (2,2):5 }, None, "la risposta della funzione  non e' corretta")
    return 2
    
def test_es9a_2():
    ''' \nSecondo test della funzione es9  dove vengono passati i due dizionari:
    d1={(1,1):1,(2,3):2,(1,3):3}
    d2={(1,1):1,(2,2):2,(2,3):3,(1,2):5}'''
    dc={(1,1):1,(2,3):2,(1,3):3}
    dd={(1,1):1,(2,2):2,(2,3):3,(1,2):5}
    returned = program.es9(dc,dd)
    check(dc, {(1,1):1,(2,3):2,(1,3):3}, None, "I dizionari in input non vanno modificati")
    check(dd, {(1,1):1,(2,2):2,(2,3):3,(1,2):5}, None, "I dizionari in input non vanno modificati")
    check(returned, {(1, 1): 2, (2, 3): 5, (1, 3): 3, (2, 2): 2, (1, 2): 5} , None, "la risposta della funzione  non e' corretta")
    return 2
    
def test_es9a_3():
    ''' \nTerzo test della funzione es9  dove vengono passati i due dizionari:
    d1={(1,1):5,(1,2):5,(2,1):5,(2,2):5}
    d2={(3,1):1,(4,2):1,(4,3):1,(3,2):1}'''
    de={(1,1):5,(1,2):5,(2,1):5,(2,2):5}
    df={(3,1):1,(4,2):1,(4,3):1,(3,2):1}
    returned = program.es9(de,df)
    check(de, {(1,1):5,(1,2):5,(2,1):5,(2,2):5}, None, "I dizionari in input non vanno modificati")
    check(df, {(3,1):1,(4,2):1,(4,3):1,(3,2):1}, None, "I dizionari in input non vanno modificati")
    check(returned, {(1, 1): 5, (1, 2): 5, (2, 1): 5, (2, 2): 5, (3, 1): 1, (4, 2): 1, (4, 3): 1, (3, 2): 1} , None, "la risposta della funzione  non e' corretta")
    return 2
    
################################################################################

def test_es10a_1():
    ''' \nPrimo test della funzione es10  dove si utilizza il file  'ftesto10_1.txt' :'''
    returned = program.es10('ftesto10_1.txt')
    check(returned, {1: [3, 4, 5], 6: [6, 7], 8: [9]} , None, "la risposta della funzione  non e' corretta")
    return 2

def test_es10a_2():
    ''' \nSecondo test della funzione es10  dove si utilizza il file  'ftesto10_2.txt' :'''
    returned = program.es10('ftesto10_2.txt')
    check(returned, {1: [3, 4, 5], 6: [6, 7], 8: [9, 10, 13], 5: [1, 6], 7: [21]} , None, "la risposta della funzione  non e' corretta")
    return 2
    
def test_es10a_3():
    ''' \nTerzo test della funzione es10  dove si utilizza il file  'ftesto10_3.txt' :'''
    returned = program.es10('ftesto10_3.txt')
    check(returned, {1: [2, 3, 4, 4], 6: [7], 8: [9, 10, 11, 12, 13], 14: [15, 16, 17, 18]} , None, "la risposta della funzione  non e' corretta")
    return 2
    
################################################################################

tests = [
    test_nome_cognome_matricola,
    test_es2a_1, test_es2a_2, test_es2a_3,
    test_es3a_1,test_es3a_2,test_es3a_3,
    test_es5a_1, test_es5a_2, test_es5a_3,
    test_es7a_1, test_es7a_2, test_es7a_3,
    test_es9a_1, test_es9a_2, test_es9a_3,
    test_es10a_1, test_es10a_2, test_es10a_3,
]

if __name__ == '__main__':
    # runtests(tests)
    runtests(tests, logfile='grade.csv')

################################################################################


