 
import albero
def es1(tree1,tree2):
    '''
    Es 1: ? punti
    Si definisca la funzione es1(tree1,tree2) ricorsiva (o che fa uso di funzioni o 
    metodi ricorsive/i) che:
    - riceve come argomenti 'tree1' e 'tree2' due alberi  formati da nodi di tipo 
      AlberoBinario definito nella libreria albero.py allegata
    - Genera un albero di tipo AlberoBinario
    - torna come risultato la radice dell'albero generato.
    I due alberi in input hanno identica struttura ma l'informazione contenuta nel campo 
    valore dei nodi corrispondenti puo' essere diversa. L'albero da generare deve avere  
    la stessa struttura dei due alberi in input. Dati due nodi corrispondenti di tree1 e 
    tree2 con valori  pari a x e y rispettivamente, il valore  del nodo corrispondente 
    in tree3 deve essere il minimo tra x e y. 
    Esempio: se tree1 e tree2 sono i due alberi sotto a sinistra allora tree3 sara' 
    l'albero sotto a destra
    
             1              7         			   1        .
            /\             /\         		           /\       .
           2  3           1  3        		          1  3      .
          / \            / \         			 / \        .
        4    5          4   6        			4   5       .
       /    /          /   /       		       /   /        .
      6    7          5   2      		      5   2         .
     /     \         /    \                          /    \         .
     8      9       9      8                        8      8        .
     

     I due alberi in input non vanno modificati
    '''
    # inserisci qui il tuo codice
    tree3=albero.AlberoBinario(min(tree1.valore, tree2.valore))
    if tree1.sx: 
        tree3.sx=es1(tree1.sx,tree2.sx)
    if tree1.dx: 
        tree3.dx=es1(tree1.dx,tree2.dx)
    return tree3
###############################################################################################


import albero
def es2(tree):
    '''
    Es 2: ? punti
    Si definisca la funzione es2(tree) ricorsiva (o che fa uso di funzioni o metodi ricorsive/i) che:
    - riceve come argomento 'tree' un  albero  formato da nodi di tipo 
      AlberoBinario definito nella libreria albero.py allegata
    - calcola il numero di nodi che nell'albero hanno ESATTAMENTE due figli
    - torna come risultato il numero calcolato
    Esempio: se l'albero e':
    
             7          
            /\         
           1  3         
          / \          
        4    6        
       /    /         
      5    2         
     /     \         
    9       8      
     
Nell'albero ci sono solo due nodi con esattamente due figli (il nodo con valore 7 ed il nodo
con valore 1) cosi'  la funzione tornera' il valore 2. 
    '''
    # inserisci qui il tuo codice
    if tree== None: return 0
    count= es2(tree.sx)+ es2(tree.dx)
    if tree.sx!= None and tree.dx!=None: count+=1
    return count
    
###############################################################################################

import immagini
def es3(fimm1,fimm2,fimm3):
    '''    
    Es 3: ? punti
    Si definisca la  funzione es3(fimm1,fimm2,fimm3) che, 
    - riceve gli  indirizzi di due file .PNG da leggere (fimm1 e fimm2) e l'indirizzo 
      di un file (fimm3) .PNG da creare.
    - legge le due immagini e crea la terza immagine da salvare all'indirizzo fimm3. 
      La terza immagine si ottiene dalle prime due. Ha ampiezza  minima tra 
      le ampiezze  di fimm1 e fimm2 ed  altezza minima tra le altezze di fimm1 e fimm2.
      il pixel [i][j] dell'immagine fimm3 ha lo stesso colore del pixel corrispondente
      dell'immagine fimm1 se i e j sono entrambi numeri pari o entrambi numeri dispari, 
      ha il colore del pixel corrispondente in  fimm2 altrimenti
    - salva l'immagine creata all'indirizzo fimm3
    - calcola  il numero di pixel presenti nell'immagine creata per i quali  la somma delle 
      tre coordinate del colore e' un numero dispari.
      - restituisce il valore calcolato
    Per caricare e salvare i file PNG si possono usare load e save della libreria immagini.
    '''
    # inserisci qui il tuo codice
    img1 = immagini.load(fimm1)
    img2 = immagini.load(fimm2)
    w1, h1 = len(img1[0]), len(img1)
    w2, h2 = len(img2[0]), len(img2)
    w3= min(w1,w2)
    h3= min(h1,h2)
    img3=[[ (0,0,0) for _ in range(w3) ] for _ in range(h3) ]
    count=0
    for i in range(h3):
        for j in range(w3):
            img3[i][j]= img2[i][j]
            if i%2==j%2: img3[i][j]= img1[i][j]
            a,b,c= img1[i][j]
            if (a+b+c)%2:count+=1     
    immagini.save(img3,fimm3)
    return count

###############################################################################################


def es4(s,ftesto):
    '''    
    Es 4: ? punti
    Si definisca la  funzione es4(s,ftesto) che,
    - riceve una stringa s di almeno due caratteri  e l'indirizzo di  un file di 
      testo 'ftesto' contenente stringhe di  caratteri separate da spazi e/o  virgole e/o 
      andate a capo. 
    - verifica se scambiando di posto due caratteri di s e' possibile ottenere una 
      delle stringhe presenti nel file
    - restituisce True se la verifica ha avuto esito positivo, false altrimenti.
    ESEMPI: 
    se il  file consiste nel testo "ba, \n\n abc  dabc, aaaa \nc cc acs" 
    con s='dcba' la funzione restituisce True (infatti per ottenere 'dcba' basta scambiare
    tra loro il secondo e quarto simbolo della stringa 'dabc' )
    mentre con  s='abc' o anche s='abcd' la funzione restituisce False.
    '''
    # inserisci qui il tuo codice
    with open(ftesto, encoding='utf8') as f:
        testo=f.read()
    testo=testo.replace(',',' ')
    ls=testo.split()
    for i in range(0,len(s)-1):
        for j in range(i+1,len(s)):
            stringa=s[:i]+s[j]+s[i+1:j]+s[i]+s[j+1:]
            if stringa in ls: return True
    return False
        

##########################################################################################


def es5(s,k):
    '''
    Es 5: ? punti
    progettare la funzione es5(s,k) che: 
    - riceve  in input una stringa s di caratteri che sono le cifre da  '0' a '9'  ed un intero k 
    - costruisce la lista con  le diverse sottostringhe  di s di lunghezza k i cui caratteri sono in 
      ordine strettamente crescente.
    - restituisce la lista dopo averne ordinato gli elementi in ordine decrescente
   Nota che la lista non deve contenere duplicati. 
   Si ricorda che una sottostringa di s e' quello che si ottiene da s eliminando 0 o piu' 
   caratteri iniziali  e 0 o piu' caratteri finali.
   ESEMPI: 
   con  s='9135918246556' e k=3 la funzione restituisce la lista ['359','246', 135']
   con  s='1234123412341234' e k=3 la funzione restituisce la lista ['234',123']
   con  s='987654321' e k=3 la funzione restituisce la lista []
    '''
    # inserisci qui il tuo codice
    insieme={ s[i:i+k] for i in range(len(s)-k+1) if crescente(s[i:i+k])}
    return sorted(list(insieme),reverse=True)

def crescente(stringa):
    for i in range(len(stringa)-1):
        if stringa[i]>=stringa[i+1]:return False
    return True

##########################################################################################

def es6(insi):
    '''
    Es 6: ? punti 
    progettare la funzione es6(insi) che: 
    - riceve  in input un insieme di numeri naturali 
    - trova le coppie di interi nell'insieme che sono tra loro coprimi
    - restituisce l'insieme con tutte le coppie di coprimi trovate. 
      Nell'insieme restituito le coppie di co-primi devono essere  rappresentate tramite tuple.
      Il co-primo piu' piccolo di ciascuna tupla  deve comparire nella prima coordinata della tupla.
     Si ricorda che:.
     Due numeri interi a e b si dicono co-primi, se e solo se essi non hanno nessun 
     divisore comune eccetto 1 e - 1, o, equivalentemente, se il loro massimo comun divisore è 1.
     ESEMPIO:
     se insi={ 6, 35, 49} la funzione restituisce l'insieme contenente le sole due  
     tuple (6,35) e(6,49). Infatti delle 3 coppie di interi che e' possibile formare 
     con gli elementi di insi, la coppia data da 35 e 49 non e' una coppia di coprimi 
     (i due numeri sono entrambi divisibili per 7).
    '''
    # inserisci qui il tuo codice.
    return { (min(i,j),max(i,j)) for i in insi for j in insi if i!=j and coprimi(i,j)   }
 
 
def coprimi(a,b):
    c=min(a,b)
    for i in range(2,c+1):
        if a%i==0 and b%i==0:return False
    return True    

##########################################################################################
 
def es7(ls, c):
    '''
    Es 7: ? punti 
    progettare la funzione es7(ls,c) che: 
    - riceve  in input una lista di parole ls ed un carattere c
    - cancella da ls le parole che contengono il carattere c (sia in maiuscolo che in minuscolo)
    - restituisce il numero di parole cancellate da ls. 
    Nota che al termine della funzione la lista passata come parametro deve risultare modificata
    (ricorda che le liste sono mutabili). 
     ESEMPI:
     Se ls=[ 'Angelo', 'Andrea', 'Fabio', 'Francesco', 'Lucio','Luca', 'Ugo'] e c='a'
     la funzione restituisce 5 e la lista ls diventa ['Lucio','Ugo']  
     Se ls=[ 'Angelo', 'Andrea', 'Fabio', 'Francesco', 'Lucio', 'Luca','Ugo'] e c='G'
     la funzione restituisce 2 e la lista ls diventa ['Andrea', 'Fabio', 'Francesco', 'Lucio','Luca']
    '''
    # inserisci qui il tuo codice.
    ls1=[ s for s in ls if not c.lower() in s.lower()]
    count=len(ls)-len(ls1)
    ls[:]=ls1
    return count

  
###############################################################################################    
    


def es8(fimm,fimm1):
    '''    
    Es 8: ? punti
    Si definisca la  funzione es8(fimm,fimm1) che, 
    - riceve gli  indirizzi fimm e fimm1 di due file .PNG. 
    - legge l'immagine da fimm e crea una seconda  immagine. L'immagine da creare 
      ha le stesse dimensioni di quella letta ed  ogni pixel della nuova immagine ha 
      lo stesso colore del pixel corrispondente della prima o in alternativa il colore rosso (255,0,0). 
      Ha lo stesso colore del pixel corrispondente della prima se il pixel della prima 
      immagine e' quello piu' in alto a sinistra ad avere quel colore (vale a dire: nello scorrere 
      per riga e poi per colonne i pixel dell'immagine, il colore di quel pixel appare per la prima volta) 
    - salva l'immagine creata all'indirizzo fimm.
    - restituisce il numero di pixel rossi (i.e. con colore (255,0,0)) presenti nell'immagine creata.
    Per caricare e salvare i file PNG si possono usare load e save della libreria immagini.
    '''
    # inserisci qui il tuo codice
    img = immagini.load(fimm)
    w, h = len(img[0]), len(img)
    img1=[[ (0,0,0) for _ in range(w) ] for _ in range(h) ]
    d={}
    count=0
    for i in range(h):
        for j in range(w):
            if img[i][j] in d: 
                d[img[i][j]]+=1
                img1[i][j]=(255,0,0)
                count+=1
            else: 
                d[img[i][j]]=1
                img1[i][j]=img[i][j]
                if img[i][j]==(255,0,0): count+=1
    immagini.save(img1,fimm1)
    return count
    
###############################################################################################    
    
# Una matrice si dice sparsa se ha pochi valori diversi da zero. Per risparmiare spazio 
# di memoria, anziche' utilizzare liste di liste  possiamo rappresentare matrici 
# sparse tramite dizionari. Il dizionario di una matrice sparsa M ha come chiavi delle tuple  
# e come attributo degli interi. Le tuple sono coppie e la coppia (i,j) e' presente nel dizionario 
# se e solo se M[i][j] e' diverso  da zero. L'attributo della chiave (i,j) sara' poi proprio M[i][j].
# ad ESEMPIO il dizionario 
# d={(0,2): 4,(1,0): 1, (1,1): 2, (2,1):8 } rappresenta la matrice quadrata  M=
# | 0 0 4 |
# | 1 2 0 |
# | 0 8 0 |

def es9(d1,d2):
    '''
    Es 9: ? punti
    Si definisca la  funzione es9(d1,d2) che, 
    - riceve due dizionari di matrici sparse della stessa dimensione.
    - restituisce un dizionario con la matrice sparsa somma delle due matrici avute in input.
    Ad ESEMPIO se
    d1={(0,2): 4,(1,0): 1, (1,1): 2, (2,1):8 } e d2={(0,0): 5,(1,1): 2, (2,2): 5, (1,0):2 }
    allora la funzione restituira' il dizionario 
    {(0,2): 4,(1,0): 3, (1,1): 4, (2,1):8, (0,0):5, (2,2):5 }
    I dizionari ricevuti non devono essere modificati
    '''
    # inserisci qui il tuo codice
    d={ x:d1[x] for x in d1}
    for x in d2:
        if x not in d:
            d[x]=d2[x]
        else: 
            d[x]+=d2[x]
    return d

###############################################################################################    
    
def es10(ftesto):
    '''
    Es 10: ? punti
    Si definisca la  funzione es10(ftesto) che, 
    - riceve l'indirizzo di un file di testo.
    - restituisce un dizionario con chiavi degli interi e attributi delle liste di interi.
    Il dizionario da restituire e' contenuto all'interno del file di testo dove e' presente 
    una sequenza di interi 
    inframmezzata da un numero arbitrario di spazi (' '), andate a capo ('\n') e due punti (':').
    Le chiavi del dizionario sono seguite da sempre dai ':' e poi dagli elementi della lista attributo.
    ESEMPI:
    se il file contiene il testo
    """
    3 : 3 6 9
    2: 4 6 10
    """
    la funzione restituira' il dizionario { 3: [3,6,9], 2: [4,6,10]}
    Se il file contiene 
    """     4: 5 6: 7        8 
    9 10 11:12 13:14 
    15""" 
    la funzione restituira' il dizionario {4:[5], 6:[7,8,9,10], 11:[12], 13:[14,15]}
    '''
    # inserisci qui il tuo codice
    with open(ftesto, encoding='utf8') as f: 
        testo=f.read()
    lista=testo.split(':')
    for i in range(len(lista)): 
        lista[i]=[int(x) for x in lista[i].split()]
    lista1=[ [lista[i-1][-1]]+lista[i][:-1] for i in range(1,len(lista)-1)]
    lista1+=[[lista[-2][-1]]+lista[-1]]
    return {elem[0]:elem[1:] for elem in lista1}
